您的位置:首页 > 其它

HDU 2955 Robberies

2018-03-27 23:20 169 查看

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 28335    Accepted Submission(s): 10395


[align=left]Problem Description[/align]The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.



For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this. 
[align=left]Input[/align]The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj . 
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj . 
[align=left]Output[/align]For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds. 
[align=left]Sample Input[/align]
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05 
[align=left]Sample Output[/align]
2
4
6 题解:
概率是小数,因此无法用数组下标来存,
dp[i]=j表示偷到i元的被抓的最小概率为j。
代码:

#include<bits/stdc++.h>
using namespace std;
int val[102];
double cost[102],dp[10003];
int main()
{
int T;
scanf("%d",&T);
while(T--)
{
int n,sum=0;
double p;
scanf("%lf%d",&p,&n);
for(int i=1; i<=n; i++)
{
scanf("%d%lf",&val[i],&cost[i]);
sum+=val[i];
}
for(int i=0; i<=sum; i++)dp[i]=0;
dp[0]=1;
for(int i=1; i<=n; i++)
{
for(int j=sum; j>=val[i]; j--)
dp[j]=max(dp[j],dp[j-val[i]]*(1-cost[i]));
}
for(int i=sum; i>=0; i--)
if(dp[i]>1-p)
{
printf("%d\n",i);
break;
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: